unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls,registry, Menus, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,WinSock;
type
MyProcType = procedure(state:boolean); stdcall;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    StartClickBtn: TButton;
    OpenDialog1: TOpenDialog;
    WriteReg: TButton;
    DeleteReg: TButton;
    Label1: TLabel;
    Label2: TLabel;
    MonitorShutDownBtn: TButton;
    StartLogBtn: TButton;
    HelpOnBtn: TButton;
    HelpOffBtn: TButton;
    ClearBtn: TButton;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    SaveDialog1: TSaveDialog;
    CheckBox1: TCheckBox;
    procedure Timer1Timer(Sender: TObject);
    procedure StartClickBtnClick(Sender: TObject);
    procedure WaitFor(interval:integer);
    procedure MonitorShutDownBtnClick(Sender: TObject);
    procedure SimulateKeyDown(Key:byte);
    procedure SimulateKeyUp(Key:byte);
    procedure SimulateKeyStroke(Key:byte;extra:Dword);
    procedure StartLogBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HelpOnBtnClick(Sender: TObject);
    procedure HelpOffBtnClick(Sender: TObject);
    procedure WriteRegClick(Sender: TObject);
    procedure DeleteRegClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  LookForStopKey:boolean;
  TimeOfLastEvent:integer;
  hLib:cardinal;
  TimerStartIndex:integer;

implementation

{$R *.dfm}

Function LogFilePath:String;
var
buf: array [0..255] of char;
s:string;
begin
GetTempPath(255,Buf);
s:=buf + 'mouselog.txt';
Result:=s;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
p:TPoint;
min,hour,sec,MiliSec:int64;
buf:real;
go:MyProcType;
LastString:string;
begin
if LookForStopKey then
begin
if (GetKeyState(120) <> 0) and (GetKeyState(120) <> 1) then
begin
@go:=GetProcAddress(hLib,'go');
go(false);
LookForStopKey:=false;
FreeLibrary(hLib);

Memo1.Lines.LoadFromFile(LogFilePath);
LastString := Memo1.Lines[Memo1.Lines.Count-1];
LastString:=copy(LastString,1,length(LastString)-2);
Memo1.Lines[Memo1.Lines.Count-1]:=LastString;

//form1.WindowState:=wsNormal;
form1.Show;
end;
end;

if (GetKeyState(123) <> 0) and (GetKeyState(123) <> 1) then
begin
TerminateProcess(GetCurrentProcess,0);
end;

GetCursorPos(p);
StatusBar1.Panels[0].Text:='X = '+inttostr(p.X)+
                     '      Y = '+IntToStr(p.Y);
MiliSec:=GetTickCount;
hour:=Trunc(MiliSec/3600000);
buf:=MiliSec - hour*3600000;
min:=Trunc(buf/60000);
buf:=buf - min*60000;
sec:=Trunc(buf/1000);
StatusBar1.Panels[1].Text:='         ( '+
                           IntToStr(hour)+' : '+
                           ''+IntToStr(min)+' : '+
                           ''+IntToStr(sec)+'  )';

{
x:=401;
y:=324;
SetCursorPos(x,y);
mouse_event(MOUSEEVENTF_LEFTDOWN,x,y,0,GetMessageExtraInfo);
mouse_event(MOUSEEVENTF_LEFTUP,x,y,0,GetMessageExtraInfo);
}
end;

procedure TForm1.StartClickBtnClick(Sender: TObject);
var
s:string;
buf:string;
i,j:integer;
n,index:integer;
x,y:integer;
WaitInterval:integer;
CursorPos:TPoint;
ScanKeyCode:integer;
begin
//form1.WindowState:=wsMinimized;
form1.Hide;
{MoveTo(x,y)
Left_Button_Down
Left_Button_Up
Left_Button_Click
Right_Button_Down
Right_Button_Up
Right_Button_Click
Wait(intervar)
MonitorOff
MonitorOnn}
{
MOVETO(X,Y)
LEFT_BUTTON_DOWN
LEFT_BUTTON_UP
LEFT_BUTTON_CLICK
RIGHT_BUTTON_DOWN
RIGHT_BUTTON_UP
RIGHT_BUTTON_CLICK
WAIT(INTERVAR)

KeyUp(key);
KeyDOwn(key);

Start_Timer
Stop_Timer
}
i:=0;
//for i:=0 to memo1.Lines.Count - 1 do
while i < memo1.Lines.Count do
begin
  s:=memo1.Lines[i];

  // 
  if pos('//',s) <> 0 then
  s:=copy(s,1,pos('//',s)-1);

  s:=Trim(s);
  s:=UpperCase(s);

  //  MoveTo
  if pos('MOVETO',s) <> 0  then
  Begin
  index:=pos('MOVETO',s);
  index:=index+7;
  for j:=index to length(s) do
  if s[j] = ','then
  begin
  n:=j-index;
  break;
  end;
  buf:=copy(s,index,n);
  buf:=trim(buf);
  x:=StrToInt(buf);//memo2.Lines.Add(buf);
  index:=j+1;
  for j:=index to length(s) do
  if s[j] = ')'then
  begin
  n:=j-index;
  break;
  end;
  buf:=copy(s,index,n);
  buf:=trim(buf);
  y:=StrToInt(buf);//memo2.Lines.Add(buf);

  SetCursorPos(x,y);
  end;

  if pos('WAIT',s) <> 0 then
  begin
    index:=pos('WAIT',s);
    index:=index+5;
    for j:=index to length(s) do
    if s[j] = ')'then
    begin
      n:=j-index;
      break;
    end;
    buf:=copy(s,index,n);
    buf:=Trim(buf);
    WaitInterval:=StrToInt(buf);

    WaitFor(WaitInterval);
  end;

  if pos('LEFT_BUTTON_DOWN',s) <> 0 then
  begin
  GetCursorPos(CursorPos);
  mouse_event(MOUSEEVENTF_LEFTDOWN,CursorPos.X,CursorPos.Y,0,GetMessageExtraInfo);
  end;

  if pos('LEFT_BUTTON_UP',s) <> 0 then
  begin
  GetCursorPos(CursorPos);
  mouse_event(MOUSEEVENTF_LEFTUP,CursorPos.X,CursorPos.Y,0,GetMessageExtraInfo);
  end;

  if pos('LEFT_BUTTON_CLICK',s) <> 0 then
  begin
  GetCursorPos(CursorPos);
  mouse_event(MOUSEEVENTF_LEFTDOWN,CursorPos.X,CursorPos.Y,0,GetMessageExtraInfo);
  mouse_event(MOUSEEVENTF_LEFTUP,CursorPos.X,CursorPos.Y,0,GetMessageExtraInfo);
  end;

  if pos('RIGHT_BUTTON_DOWN',s) <> 0 then
  begin
  GetCursorPos(CursorPos);
  mouse_event(MOUSEEVENTF_LEFTDOWN,CursorPos.X,CursorPos.Y,0,GetMessageExtraInfo);
  end;

  if pos('RIGHT_BUTTON_UP',s) <> 0 then
  begin
  GetCursorPos(CursorPos);
  mouse_event(MOUSEEVENTF_LEFTUP,CursorPos.X,CursorPos.Y,0,GetMessageExtraInfo);
  end;

  if pos('RIGHT_BUTTON_CLICK',s) <> 0 then
  begin
  GetCursorPos(CursorPos);
  mouse_event(MOUSEEVENTF_LEFTDOWN,CursorPos.X,CursorPos.Y,0,GetMessageExtraInfo);
  mouse_event(MOUSEEVENTF_LEFTUP,CursorPos.X,CursorPos.Y,0,GetMessageExtraInfo);
  end;

  if pos('MONITOROFF',s) <> 0 then
  begin
  SendMessage(Application.Handle,wm_SysCommand,SC_MonitorPower,1);
  end;

    if pos('MONITORONN',s) <> 0 then
  begin
  SendMessage(Application.Handle,wm_SysCommand,SC_MonitorPower,-1);
  end;

  if pos('KEYDOWN',s) <> 0 then
  begin
    index:=pos('KEYDOWN',s);
    index:=index+8;
    for j:=index to length(s) do
    if s[j] = ')'then
    begin
      n:=j-index;
      break;
    end;
    buf:=copy(s,index,n);
    buf:=Trim(buf);
    ScanKeyCode:=StrToInt(buf);

    SimulateKeyDown(ScanKeyCode);
  end;

  if pos('KEYUP',s) <> 0 then
  begin
    index:=pos('KEYUP',s);
    index:=index+6;
    for j:=index to length(s) do
    if s[j] = ')'then
    begin
      n:=j-index;
      break;
    end;
    buf:=copy(s,index,n);
    buf:=Trim(buf);
    ScanKeyCode:=StrToInt(buf);

    SimulateKeyUp(ScanKeyCode);
  end;

  if pos('KEYPRESS',s) <> 0 then
  begin
    index:=pos('KEYPRESS',s);
    index:=index+9;
    for j:=index to length(s) do
    if s[j] = ')'then
    begin
      n:=j-index;
      break;
    end;
    buf:=copy(s,index,n);
    buf:=Trim(buf);
    ScanKeyCode:=StrToInt(buf);

    SimulateKeyStroke(ScanKeyCode,0);
  end;

  if pos('START_TIMER',s) <> 0 then
  begin
    TimerStartIndex:=i;
  end;

  if pos('STOP_TIMER',s) <> 0 then
  begin
    i := TimerStartIndex;
  end;

//  memo2.Lines.Add(s);
  i := i + 1;

end;
form1.Show;
//form1.WindowState:=wsNormal;
end;

procedure TForm1.WaitFor(interval: integer);
var
TheTime : LongInt;
begin
TheTime := GetTickCount + interval;
while GetTickCount < TheTime do
Application.ProcessMessages;
end;

procedure TForm1.MonitorShutDownBtnClick(Sender: TObject);
var
wnd:thandle;
ChildWnd:thandle;
WindowText:array [0..255] of char;
ClassName:array [0..255] of char;
begin
SendMessage(Application.Handle,wm_SysCommand,SC_MonitorPower,1);
end;

procedure TForm1.SimulateKeyDown(Key: byte);
begin
keybd_event(Key,0,0,0);
end;

procedure TForm1.SimulateKeyStroke(Key: byte; extra: Dword);
begin
keybd_event(Key,extra,0,0);
keybd_event(Key,extra,KEYEVENTF_KEYUP,0);
end;

procedure TForm1.SimulateKeyUp(Key: byte);
begin
keybd_event(Key,0,KEYEVENTF_KEYUP,0);
end;

procedure TForm1.StartLogBtnClick(Sender: TObject);
var
go:MyProcType;
f:Cardinal;
begin
//Form1.WindowState:=wsMinimized;
form1.Hide;
hLib:=LoadLibrary('keylog.dll');
@go:=GetProcAddress(hLib,'go');
go(true);
LookForStopKey:=true;
DeleteFileA(pchar(LogFilePath));
end;

procedure TForm1.FormCreate(Sender: TObject);
var
TempFile:string;
reg:TRegistry;
HostEnt:PHostEnt;
param:string;
begin
reg:=TRegistry.Create;
reg.RootKey:=HKEY_LOCAL_MACHINE;
reg.LazyWrite:=false;
if reg.KeyExists('software\clicker') then
begin
reg.OpenKey('software\clicker',true);
TempFile := reg.ReadString('RunFile');
reg.CloseKey;
memo1.Lines.LoadFromFile(TempFile);
end;

param:=ParamStr(1);
if param = 'autorun' then
begin
  if ParamStr(2) = 'true' then
  begin
    FillChar(HostEnt,SizeOf(HostEnt),0);
    while HostEnt = nil do
    begin
      HostEnt:=gethostbyname('google.com');
      WaitFor(1000);
    end;
  end;
  StartClickBtn.Click;
end;

LookForStopKey:=false;
HelpOffBtn.Click;
label2.Caption:='  :' + chr(13) +
                'MoveTo(x,y)' + chr(13) +
                'Left_Button_Down -    ' + chr(13) +
                'Left_Button_Up -    ' + chr(13) +
                'Left_Button_Click -    ' + chr(13) +
                'Right_Button_Down  -    ' + chr(13) +
                'Right_Button_Up -    ' + chr(13) +
                'Right_Button_Click -    ' + chr(13) +
                'Wait(intervar) - ' + chr(13) +
                'MonitorOff -  ' + chr(13) +
                'MonitorOnn -  ' + chr(13) +
                'KeyUp(key) -  ' + chr(13) +
                'KeyDown(key) -  ' + chr(13) +
                'KeyPress(key) - (+) ' + chr(13) +
                'Start_Timer -  ' + chr(13) +
                'Stop_Timer -  ' + chr(13) +
                 chr(13) +
                'F9 -  ' + chr(13) +
                'F7 -   ' + chr(13) +
                'F8 -   ' + chr(13) +
                'F10 -  ';
{MoveTo(x,y)
Left_Button_Down
Left_Button_Up
Left_Button_Click
Right_Button_Down
Right_Button_Up
Right_Button_Click
}
{
MOVETO(X,Y)
LEFT_BUTTON_DOWN
LEFT_BUTTON_UP
LEFT_BUTTON_CLICK
RIGHT_BUTTON_DOWN
RIGHT_BUTTON_UP
RIGHT_BUTTON_CLICK
WAIT(INTERVAR)

KeyUp(key);
KeyDOwn(key);
}

end;

procedure TForm1.HelpOnBtnClick(Sender: TObject);
begin
form1.Width:=form1.Width + 441;
HelpOnBtn.Visible:=false;
end;

procedure TForm1.HelpOffBtnClick(Sender: TObject);
begin
HelpOnBtn.Visible:=true;
form1.Width:=form1.Width - 441;
end;

procedure TForm1.WriteRegClick(Sender: TObject);
var
SubKey:string;
Key:HKey;
MyFileName:string;
begin
if CheckBox1.Checked then
MyFileName:=ParamStr(0)+' autorun true'
else
MyFileName:=ParamStr(0)+' autorun false';
SubKey:='software\microsoft\windows\currentversion\run';
RegCreateKeyEx(HKEY_LOCAL_MACHINE,pchar(SubKey),0,NIL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NIL,Key,0);
RegSetValueExA(Key,'clicker',0,REG_SZ,pchar(MyFileName),length(MyFileName));
RegCloseKey(key);
end;

procedure TForm1.DeleteRegClick(Sender: TObject);
var
SubKey:string;
Key:HKey;
begin
SubKey:='software\microsoft\windows\currentversion\run';
RegCreateKeyEx(HKEY_LOCAL_MACHINE,pchar(SubKey),0,NIL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NIL,Key,0);
RegDeleteValue(Key,'clicker');
RegCloseKey(key);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
SubKey:string;
Key:HKey;
TempFilePath:string;
buf:array [0..255] of char;
begin
GetTempPathA(255,buf);
TempFilePath := buf + 'ClickerCode.txt';
memo1.Lines.SaveToFile(TempFilePath);
SubKey := 'software\clicker';
RegCreateKeyEx(HKEY_LOCAL_MACHINE,pchar(SubKey),0,NIL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NIL,Key,0);
RegSetValueExA(Key,'RunFile',0,REG_SZ,pchar(TempFilePath),length(TempFilePath));
RegCloseKey(key);
end;

procedure TForm1.N2Click(Sender: TObject);
begin
if SaveDialog1.Execute then
memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.N3Click(Sender: TObject);
begin
if OpenDialog1.Execute then
memo1.Lines.LoadFromFile(OpenDialog1.FileName);
end;

procedure TForm1.ClearBtnClick(Sender: TObject);
begin
Memo1.Clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
HostEnt:PHostEnt;
s:string;
p:pchar;
i:integer;
buf:array [0..255] of char;
begin
ShowMessage(LogFilePath);
end;

end.
